From de97ad711cfc5db251352c44867a245934d7a717 Mon Sep 17 00:00:00 2001
From: manish <manish10@gmail.com>
Date: Fri, 19 Jul 2013 14:40:45 +0530
Subject: [PATCH] fix for ticket #3288 read by sentence in word.

---
 source/NVDAObjects/window/winword.py | 23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

diff --git a/source/NVDAObjects/window/winword.py b/source/NVDAObjects/window/winword.py
index d43cdbf..fe9fb81 100755
--- a/source/NVDAObjects/window/winword.py
+++ b/source/NVDAObjects/window/winword.py
@@ -480,6 +480,27 @@ class WordDocument(EditableTextWithoutAutoSelectDetection, Window):
 	def script_previousColumn(self,gesture):
 		self._moveInTable(row=False,forward=False)
 
+	def _moveBySentence(self, direction=1):
+		""" Helper method to move by sentence
+		@param direction: positive for next negative for or previous
+		@type direction: int
+		"""
+		info=self.makeTextInfo(textInfos.POSITION_CARET)
+		info.expand(textInfos.UNIT_SENTENCE)
+		end = True if direction > 0 else False
+		info.collapse(end)
+		info.move(textInfos.UNIT_SENTENCE, direction, end)
+		info.expand(textInfos.UNIT_SENTENCE)
+		speech.speakTextInfo(info,reason=controlTypes.REASON_CARET)
+		info.collapse()
+		info.updateCaret()
+
+	def script_nextSentence(self, gesture):
+		self._moveBySentence(1)
+
+	def script_previousSentence(self, gesture):
+		self._moveBySentence(-1)
+
 	__gestures = {
 		"kb:tab": "tab",
 		"kb:shift+tab": "tab",
@@ -489,5 +510,7 @@ class WordDocument(EditableTextWithoutAutoSelectDetection, Window):
 		"kb:control+alt+rightArrow": "nextColumn",
 		"kb:control+pageUp": "caret_moveByLine",
 		"kb:control+pageDown": "caret_moveByLine",
+		"kb:NVDA+control+upArrow": "previousSentence",
+		"kb:NVDA+control+downArrow": "nextSentence",
 	}
 
-- 
1.8.1.msysgit.1

